package readers;

import java.io.File;

import java.util.Vector;

public abstract class FileTestReader
    implements TestReader {
    
    public FileTestReader() {
        
        mSourceFile = null;
        mEncoding = new String( "UTF-8" );
        mLog = new Vector< String >();
    }
    
    public boolean setSource(
            Object pSource ) {
        
        if( pSource == null ) {
            return false;
        }
        if( pSource instanceof File ) {
            File lSourceFile = ( File )pSource;
            if( ! lSourceFile.exists() ) {
                return false;
            } else {
                mSourceFile = lSourceFile;
                return true;
            }
        } else {
            return false;
        }        
    }
    
    public Vector< String > getLog() {
        
        return ( Vector < String > ) mLog.clone();
    }
    
    public void setEncoding(
            String pEncoding ) {
        
        mEncoding = new String( pEncoding );
    }
    
    public String getEncoding() {
        
        return new String( mEncoding );
    }
    
    public boolean ready() {
        
        if( mSourceFile == null ) {
            return false;
        } else if( ! mSourceFile.exists() ) {
            return false;
        } else {
            return true;
        }
    }
    
    protected Vector< String > mLog;
    protected File mSourceFile;
    protected String mEncoding;
}
