package readers;

import tests.*;

import java.io.FileInputStream;
import java.io.DataInputStream;
import java.io.FileNotFoundException;

import java.io.BufferedReader;
import java.io.FileReader;

import java.util.Vector;
import java.util.StringTokenizer;

import java.util.Calendar;

import java.util.Vector;

public class TXTAlphaTestReader
    extends FileTestReader {
    
    public TXTAlphaTestReader() {
    }
    
    public Test read() {
        
        if( ! ready() ) {
            return null;
        }
        FileReader lFReader = null;
        try {
            lFReader = new FileReader( mSourceFile );
        } catch( FileNotFoundException eFailed ) {
            return null;
        }
        
        mBReader = new BufferedReader( lFReader );
        Test lResult = null;
        mLog = new Vector< String >();
        
        try {
            Vector <Author> lAuthors = parseAuthors();
            Integer lYear = new Integer( readTextLine() );
            String lDiscipline = readTextLine().toUpperCase();
            
            String lTitle;
            Integer lQuestionsNumber;
            
            String Buffer = readTextLine();
            try {
               lQuestionsNumber = new Integer( Buffer );
               lTitle = new String(lDiscipline);
            }
            catch(Exception eParseFailed) {
                lTitle = Buffer.toUpperCase();
                lQuestionsNumber = new Integer( readTextLine() );
            } 
            Integer lTestType = new Integer( readTextLine() );
            Vector< Question > lQuestions = parseQuestions(
                    lQuestionsNumber, 
                    lTestType );
            
            Author lEditor = new Author(
                                new String("4"),
                                new String(""),
                                new String(""),
                                new String(""),
                                new Department(
                                    new String(""),
                                    new String(" "),
                                    new String("  ()")
                                )
                             );
            Author lReviewer = lEditor.clone();
            Description lDescription = new Description(
                    null,
                    null,
                    null,
                    new String(lDiscipline), 
                    new String(lTitle));
            
            lResult = new Test(
                    lAuthors,
                    lEditor,
                    lReviewer,
                    lDescription,
                    lQuestions );
        } catch ( Exception eParseFailed ) {
            mLog.add( 
                    "Source TXT file has errors." );
            lResult = null;
        }
        
        return lResult;
    }
    
    private Department parseDepartment() 
        throws Exception {
        
        Department lResult = null;
        
        String lUniversity = readTextLine().toUpperCase();
        String lFaculty = readTextLine().toUpperCase();
        String lSubFaculty = readTextLine().toUpperCase();
        
        lResult = new Department(
                lUniversity,
                lFaculty,
                lSubFaculty );
        
        return lResult;
    }
    
    private Vector <Author> parseAuthors()
        throws Exception {
        
        Vector <Author> lAuthors = new Vector <Author>();
        
        Department lDepartment = parseDepartment();
                
        for (int Authors = 0; Authors < 1; Authors++)
        {
            Author lAuthor = parseAuthor(lDepartment);
            lAuthors.add(lAuthor);
        }
        return lAuthors;
    }
    
    private Author parseAuthor(Department lDepartment)
        throws Exception {
        
        Author lAuthor = null;
        
        String lName = null;
        String lSurname = null;
        String lPatronymic = null;
        String lFullName = readTextLine();
        StringTokenizer lNameTokens = new StringTokenizer( lFullName, " " );
        if ( lNameTokens.hasMoreElements() ) {
            lSurname = lNameTokens.nextToken().toUpperCase();
        }
        if ( lNameTokens.hasMoreElements() ) {
            lName = lNameTokens.nextToken().toUpperCase();
        }
        if( lNameTokens.hasMoreElements() ) {
            lPatronymic = lNameTokens.nextToken().toUpperCase();
        }
        
        if (lPatronymic == null) lPatronymic = new String("");
        
        lAuthor = new Author(new String("5"),lName,lSurname,lPatronymic,lDepartment);
        
        return lAuthor;
    }
    
    private Vector< Question > parseQuestions(
            Integer pQuestionsNumber,
            Integer pTestType )
            throws Exception {
        
        Vector< Question > lQuestions = new Vector< Question >();
        
        if( pTestType == 0 ) {
            for( int iQuestion = 0; iQuestion < pQuestionsNumber; iQuestion++ ) {
                String lContent = readTextLine();
                Vector< Answer > lAnswers = parseAnswers();
                Question lQuestion = new Question(
                        lContent,
                        null,
                        0,
                        0,
                        lAnswers );
                lQuestions.add( lQuestion );
            }
        }
        return lQuestions;
    }
    
    private Vector< Answer > parseAnswers()
            throws Exception {
        
        Vector< Answer > lAnswers = new Vector< Answer >();
        String lCorrect = "true";
        for( int iAnswer = 0; iAnswer < 4; iAnswer++ ) {
            String lContent = readTextLine();
            Answer lAnswer = new Answer(
                    lContent,
                    lCorrect );
            lCorrect = "false";
            lAnswers.add( lAnswer );
        }
        return lAnswers;
    }
    
    private String readTextLine() {
        
        String lLine = null;
        
        try {
            lLine = new String( mBReader.readLine().trim().getBytes(), mEncoding );
        } catch( Exception eReadingFailed ) {
            return null;
        }
        if( lLine.length() == 0 ) {
            lLine = readTextLine();
        }
        
        return lLine;
    }
        
    private BufferedReader mBReader;
}