package tests;

public class Answer {
    
    public Answer(
            String pContent,
            String pCorrect )
            throws IllegalArgumentException {
        
        if( pContent == null ) {
            System.out.println( "Illegal Content argument." );
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        if( pContent.trim().length() == 0 ) {
            System.out.println( "Illegal Content argument." );
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        if( pCorrect == null ) {
            System.out.println( "Illegal Correct argument." );
            throw new IllegalArgumentException( "Illegal Correct argument." );
        }
        if( pCorrect.trim().length() == 0 ) {
            System.out.println( "Illegal Correct argument." );
            throw new IllegalArgumentException( "Illegal Correct argument." );
        }
        mContent = new String( pContent );
        mCorrect = new String( pCorrect );
    }
    
    public Answer(
            Answer pPrototype ) 
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            System.out.println( "Illegal Prototype argument." );
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        mContent = new String (pPrototype.mContent);
        mCorrect = new String (pPrototype.mCorrect);
    }
    
    public void setContent(
            String pContent ) {
        
        if( pContent == null )  {
            return;
        }
        if( pContent.trim().length() == 0 ) {
            return;
        }
        mContent = new String( pContent );
    }
    
    public String getContent() {
        
        return new String( mContent );
    }
    
    public void setCorrect(
            String pCorrect ) {
        
        if( pCorrect == null )  {
            return;
        }
        if( pCorrect.trim().length() == 0 ) {
            return;
        }
        mCorrect = new String( pCorrect );
    }
    
    public String getCorrect() {
        
        return new String( mCorrect );
    }
    
    public Answer clone() {
        
        Answer lClone = null;
        try {
            lClone = new Answer( this );
        } catch ( IllegalArgumentException eFakeException ) {
            
        }
        return lClone;
    }
    
    public boolean equals( 
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        }
        if( pInstance instanceof Answer ) {
            Answer lInstance = ( Answer )pInstance;
            if( mContent.equals( lInstance.mContent ) &&
                    mCorrect.equals( lInstance.mCorrect ) ) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    private String mContent;
    private String mCorrect;   
}