package tests;

public class Author {
    
    public Author(String pCourse,String pName,String pSurname,
            String pPatronymic,
            Department pDepartment)
            throws IllegalArgumentException {
        
        if (pCourse == null) {
            System.out.println("Illegal course argument");
            throw new IllegalArgumentException( "Illegal course argument." );
        }
        if (pCourse.trim().length() == 0) {
            System.out.println("Illegal course argument");
            throw new IllegalArgumentException( "Illegal course argument." );
        }
        if( pName == null ) {
            System.out.println( "Illegal Name argument." );
            throw new IllegalArgumentException( "Illegal Name argument." );
        }
        if( pName.trim().length() == 0 ) {
            System.out.println( "Illegal Name argument." );
            throw new IllegalArgumentException( "Illegal Name argument." );
        }
        if( pSurname == null ) {
            System.out.println( "Illegal Surname argument." );
            throw new IllegalArgumentException( "Illegal Surname argument." );
        }
        if( pSurname.trim().length() == 0 ) {
            System.out.println( "Illegal Surname argument." );
            throw new IllegalArgumentException( "Illegal Surname argument." );
        }
        if( pPatronymic == null ) {
            System.out.println( "Illegal Surname argument." );
            throw new IllegalArgumentException( "Illegal Patronymic argument." );
        }
        // Don't catch patronymic size = 0 because this param may be empty
        if( pDepartment == null ) {
            System.out.println( "Illegal Department argument." );
            throw new IllegalArgumentException( "Illegal Department argument." );
        }
        
        mCourse = new String (pCourse);
        mName = new String( pName );
        mSurname = new String( pSurname );
        mPatronymic = new String(pPatronymic);
        mDepartment =  pDepartment.clone();
    }
    
    public Author( 
            Author pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            System.out.println( "Illegal Prototype argument." );
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        mCourse = new String(pPrototype.mCourse);
        mName = new String( pPrototype.mName);
        mSurname = new String( pPrototype.mSurname);
        mPatronymic = new String(pPrototype.mPatronymic);
        mDepartment = new Department(pPrototype.mDepartment);
    }
    
    public boolean setCourse(
            String pCourse ) {
        
        if( pCourse == null )  {
            return false;
        }
       
        mCourse = new String (pCourse);
        return true;
    }
    
    public String getCourse() {
        
        return new String(mCourse);
    }
    
    public boolean setName(
            String pName ) {
        
        if( pName == null )  {
            return false;
        }
        if( pName.trim().length() == 0 ) {
            return false;
        }
        mName = new String( pName );
        return true;
    }
    
    public String getName() {
        
        return new String( mName );
    }
    
    public boolean setSurname(
            String pSurname ) {
        
        if( pSurname == null )  {
            return false;
        }
        if( pSurname.trim().length() == 0 ) {
            return false;
        }
        mSurname = new String( pSurname );
        return true;
    }
    
    public String getSurname() {
        
        return new String( mSurname );
    }
    
    public boolean setPatronymic(
            String pPatronymic ) {
        
        if( pPatronymic == null )  {
            return false;
        }
        if( pPatronymic.trim().length() == 0 ) {
            return false;
        }
        mPatronymic = new String( pPatronymic );
        return true;
    }
    
    public String getPatronymic() {
        
        return new String( mPatronymic );
    }
    
    public boolean seDepartment(
            Department lDepartment ) {
        
        if( lDepartment == null )  {
            return false;
        }
        
        mDepartment = new Department( lDepartment );
        return true;
    }
    
    public Department getDepartment() {
        
        return mDepartment.clone();
    }
    
    public Author clone() {
        
        Author lClone = null;
        try {
            lClone =  new Author( this );
        } catch ( IllegalArgumentException eFakeException ) {
            
        }
        return lClone;
    }
    
    public boolean equals( 
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        }
        if( pInstance instanceof Author ) {
            Author lInstance = ( Author )pInstance;
            if( mName.equals( lInstance.mName ) &&
                    mSurname.equals( lInstance.mSurname ) ) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }	
	
    private String mCourse;
    private String mName;
    private String mSurname;
    private String mPatronymic;
    private Department mDepartment;
}