package tests;

import java.util.Vector;

public class Question {
    
    public Question(
            String pContent,
            String pExplanation,  // Doesn't handle now
            Integer Cost,
            Integer Penalty,
            Vector< Answer > pAnswers ) 
            throws IllegalArgumentException {
        
        if( pContent == null ) {
            System.out.println( "Illegal Content argument." );
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        if( pContent.trim().length() == 0 ) {
            System.out.println( "Illegal Content argument." );
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        if( pAnswers == null ) {
            System.out.println( "Illegal Answers argument." );
            throw new IllegalArgumentException( "Illegal Answers argument." );
        }
        if( pAnswers.size() == 0 ) {
            System.out.println( "Illegal Answers argument." );
            throw new IllegalArgumentException( "Illegal Answers argument." );
        }
        if (pExplanation == null) {
            mExplanation = new String("");
        }
        else mExplanation = new String(pExplanation);
        
        mContent = new String( pContent );
        mCost = Cost;
        mPenalty = Penalty;
        mAnswers = ( Vector< Answer > )pAnswers.clone();
    }
    
    public Question(
            Question pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            System.out.println( "Illegal Prototype argument." );
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        mContent = new String( pPrototype.mContent );
        mExplanation = new String( pPrototype.mExplanation );
        mCost = pPrototype.getCost();
        mPenalty = pPrototype.getPenalty();
        mAnswers = ( Vector< Answer > )pPrototype.mAnswers.clone();
    }
    
    public void setContent(
            String pContent ) {
        
        if( pContent == null )  {
            return;
        }
        if( pContent.trim().length() == 0 ) {
            return;
        }
        mContent = new String( pContent );
    }
        
    public String getContent() {
        
        return new String( mContent );
    }
    
    public void setExplanation(
            String pExplanation ) {
        
        if( pExplanation == null )  {
            return;
        }
        if( pExplanation.trim().length() == 0 ) {
            return;
        }
        mExplanation = new String( pExplanation );
    }
        
    public String getExplanation() {
        
        return new String( mExplanation );
    }
    
    public void setCost(Integer Cost) {
        mCost = Cost;
    }
    
    public Integer getCost() {
        return mCost;
    }
    
    public void setPenalty(Integer Penalty) {
        mPenalty = Penalty;
    }
    
    public Integer getPenalty() {
        return mPenalty;
    }
    
    public void setAnswers(
            Vector< Answer > pAnswers ) {
        
        if( pAnswers == null )  {
            return;
        }
        if( pAnswers.size() == 0 ) {
            return;
        }
        mAnswers = ( Vector< Answer > )pAnswers.clone();
    }
    
    public Vector< Answer > getAnswers() {
        
        return ( Vector< Answer > )mAnswers.clone();
    }
    
    public QuestionType getType() {
        
        return QuestionType.Simple;
    }
    
    public Question clone() {
        
        Question lClone = null;
        try {
            lClone = new Question( this );
        } catch( Exception eFakeException ) {
            
        }
        return lClone;
    }
    
    public boolean equals( 
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        }
        if( pInstance instanceof Question ) {
            Question lInstance = ( Question )pInstance;
            if( mContent.equals( lInstance.mContent ) &&
                    mAnswers.equals( lInstance.mAnswers ) ) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    private String mContent;
    private String mExplanation;
    private Integer mCost;
    private Integer mPenalty;
    private Vector< Answer > mAnswers;   
}