package tests;

import java.util.Vector;

public class Test {
    
    public Test(
            Vector <Author> pAuthors,
            Author pEditor,
            Author pReviewer,
            Description pDescription,
            Vector<Question> pQuestions )
            throws IllegalArgumentException {
        
        if( pAuthors == null ) {
            System.out.println( "Illegal Authors argument." );
            throw new IllegalArgumentException( "Illegal Authors argument." );
        }
        if( pAuthors.size() == 0 ) {
            System.out.println( "Illegal Authors argument." );
            throw new IllegalArgumentException( "Illegal Authors argument." );
        }
        if( pEditor == null ) {
            System.out.println( "Illegal Editor argument." );
            throw new IllegalArgumentException( "Illegal Editor argument." );
        }
        if( pReviewer == null ) {
            System.out.println( "Illegal Reviewer argument." );
            throw new IllegalArgumentException( "Illegal Reviewer argument." );
        }
        if( pDescription == null ) {
            System.out.println( "Illegal Description argument." );
            throw new IllegalArgumentException( "Illegal Description argument." );
        }
        if( pQuestions == null ) {
            System.out.println( "Illegal Questions argument." );
            throw new IllegalArgumentException( "Illegal Questions argument." );
        }
        if( pQuestions.size() == 0 ) {
            System.out.println( "Illegal Questions argument." );
            throw new IllegalArgumentException( "Illegal Questions argument." );
        }
        
        mAuthors = (Vector <Author>) pAuthors.clone();
        mEditor = pEditor.clone();
        mReviewer = pReviewer.clone();
        mDescription = pDescription.clone();
        mQuestions = ( Vector<Question> )pQuestions.clone();
    }
    
    public Test(
            Test pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            System.out.println( "Illegal Prototype argument." );
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        
        mAuthors = (Vector <Author>) pPrototype.mAuthors.clone();
        mEditor = pPrototype.mEditor.clone();
        mReviewer = pPrototype.mReviewer.clone();
        mDescription = pPrototype.mDescription.clone();
        mQuestions = ( Vector< Question > )pPrototype.mQuestions.clone();
    }
    
      public boolean setAuthors(
            Vector <Author> pAuthors ) {
        
        if( pAuthors == null )  {
            return false;
        }
        if (pAuthors.size() == 0) {
            return false;
        }
          
        mAuthors = (Vector <Author>)pAuthors.clone();
        return true;
    }
    
    public Vector <Author> getAuthors() {
        
        return (Vector <Author>)mAuthors.clone();
    }
    
    public boolean setEditor(
            Author pEditor ) {
        
        if( pEditor == null )  {
            return false;
        }
          
        mEditor = pEditor.clone();
        return true;
    }
    
    public Author getEditor() {
        
        return mEditor.clone();
    }
    
    public boolean setDescription(
            Description pDescriprion ) {
        
        if( pDescriprion == null )  {
            return false;
        }
          
        mDescription = pDescriprion.clone();
        return true;
    }
    
    public Description getDescription() {
        
        return mDescription.clone();
    }
    
    public boolean setReviewer(
            Author pReviewer ) {
        
        if( pReviewer == null )  {
            return false;
        }
          
        mReviewer = pReviewer.clone();
        return true;
    }
    
    public Author getReviewer() {
        
        return mReviewer.clone();
    }
    
    public boolean setQuestions(
            Vector< Question > pQuestions ) {
        
        if( pQuestions == null )  {
            return false;
        }
        if( pQuestions.size() == 0 ) {
            return false;
        }
        mQuestions = new Vector< Question >( pQuestions );
        return true;
    }
    
    public Vector< Question > getQuestions() {
        
        return ( Vector< Question > )mQuestions.clone();
    }
    
    public Test clone() {
        
        Test lClone = null;
        try {
            lClone = new Test( this );
        } catch( Exception eFakeException ) {
            
        }
        return lClone;
    }
    
    public boolean equals( 
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        }
        if( pInstance instanceof Test ) {
            Test lInstance = ( Test )pInstance;
            if( mDescription.equals( lInstance.mDescription ) &&
                    mAuthors.equals( lInstance.mAuthors ) &&
                    mQuestions.equals( lInstance.mQuestions ) ) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    private Vector <Author> mAuthors;
    private Author mEditor;
    private Author mReviewer;
    private Description mDescription;
    private Vector< Question > mQuestions;
    
    private static final Integer cOldestYear = new Integer( 2000 );
}