package visualization;

import javax.swing.JFileChooser;
import javax.swing.DefaultListModel;

import java.util.Vector;

import java.io.File;

import converters.DocumentsConverter;

public class LightClient 
        extends javax.swing.JFrame {
    
    public LightClient() {
        initComponents();
        mConverter = DocumentsConverter.getInstance();
        Vector< String > lInputFormats = mConverter.getInputFormats();
        for( int iFormat = 0; iFormat < lInputFormats.size(); iFormat++ ) {
            msStartingFileFormatComboBox.addItem( lInputFormats.get( iFormat ) );
        }
        Vector< String > lOutputFormats = mConverter.getOutputFormats();
        for( int iFormat = 0; iFormat < lOutputFormats.size(); iFormat++ ) {
            mResultingFileFormatComboBox.addItem( lOutputFormats.get( iFormat ) );
        }
        Vector< String > lInputEncodings = mConverter.getInputEncodings();
        for( int iEncoding = 0; iEncoding < lInputEncodings.size(); iEncoding++ ) {
            msStartingFileEncodingComboBox.addItem( lInputEncodings.get( iEncoding ) );
        }
        Vector< String > lOutputEncodings = mConverter.getOutputEncodings();
        for( int iEncoding = 0; iEncoding < lOutputEncodings.size(); iEncoding++ ) {
            mResultingFileEncodingComboBox.addItem( lOutputEncodings.get( iEncoding ) );
        }
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        mConvertingButton = new javax.swing.JButton();
        mFilesPanel = new javax.swing.JPanel();
        mSourceFileLabel = new javax.swing.JLabel();
        mSourceFileField = new javax.swing.JTextField();
        mDestinationFileLabel = new javax.swing.JLabel();
        mDestinationFileField = new javax.swing.JTextField();
        mSourceFileChooseButton = new javax.swing.JButton();
        mDestinationFileChooseButton = new javax.swing.JButton();
        mFilesLabel = new javax.swing.JLabel();
        mOptionsPanel = new javax.swing.JPanel();
        mOptionsLabel = new javax.swing.JLabel();
        msStartingFileFormatLabel = new javax.swing.JLabel();
        msStartingFileFormatComboBox = new javax.swing.JComboBox();
        msResultingFileFormatLabel = new javax.swing.JLabel();
        mResultingFileFormatComboBox = new javax.swing.JComboBox();
        msStartingFileEncodingLabel = new javax.swing.JLabel();
        msStartingFileEncodingComboBox = new javax.swing.JComboBox();
        mResultingFileEncodingLabel = new javax.swing.JLabel();
        mResultingFileEncodingComboBox = new javax.swing.JComboBox();
        mConvertingPanel = new javax.swing.JPanel();
        mConvertingLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        mConvertingMessagesList = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("\u041c\u043e\u0434\u0443\u043b\u044c \u043a\u043e\u043d\u0432\u0435\u0440\u0442\u0438\u0440\u043e\u0432\u0430\u043d\u0438\u044f \u0442\u0435\u0441\u0442\u043e\u0432");
        setName("mLightClientForm");
        setResizable(false);
        mConvertingButton.setText("\u041a\u043e\u043d\u0432\u0435\u0440\u0442\u0438\u0440\u043e\u0432\u0430\u0442\u044c");
        mConvertingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mConvertingButtonActionPerformed(evt);
            }
        });

        mFilesPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
        mSourceFileLabel.setText("\u0418\u0441\u0445\u043e\u0434\u043d\u044b\u0439 \u0444\u0430\u0439\u043b");

        mDestinationFileLabel.setText("\u0424\u0430\u0439\u043b \u043d\u0430\u0437\u043d\u0430\u0447\u0435\u043d\u0438\u044f");

        mSourceFileChooseButton.setText("\u041e\u0431\u0437\u043e\u0440");
        mSourceFileChooseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mSourceFileChooseButtonActionPerformed(evt);
            }
        });

        mDestinationFileChooseButton.setText("\u041e\u0431\u0437\u043e\u0440");
        mDestinationFileChooseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mDestinationFileChooseButtonActionPerformed(evt);
            }
        });

        mFilesLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        mFilesLabel.setText("\u0424\u0430\u0439\u043b\u044b");

        org.jdesktop.layout.GroupLayout mFilesPanelLayout = new org.jdesktop.layout.GroupLayout(mFilesPanel);
        mFilesPanel.setLayout(mFilesPanelLayout);
        mFilesPanelLayout.setHorizontalGroup(
            mFilesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mFilesPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(mFilesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(mFilesLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                    .add(mFilesPanelLayout.createSequentialGroup()
                        .add(mFilesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(mSourceFileField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 331, Short.MAX_VALUE)
                            .add(mDestinationFileField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 331, Short.MAX_VALUE)
                            .add(mSourceFileLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 331, Short.MAX_VALUE)
                            .add(mDestinationFileLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 331, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(mFilesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(mDestinationFileChooseButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 69, Short.MAX_VALUE)
                            .add(mSourceFileChooseButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 69, Short.MAX_VALUE))))
                .addContainerGap())
        );
        mFilesPanelLayout.setVerticalGroup(
            mFilesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mFilesPanelLayout.createSequentialGroup()
                .add(mFilesLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mSourceFileLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mFilesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(mSourceFileChooseButton)
                    .add(mSourceFileField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mDestinationFileLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mFilesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(mDestinationFileField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(mDestinationFileChooseButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        mOptionsPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
        mOptionsLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        mOptionsLabel.setText("\u041e\u043f\u0446\u0438\u0438");

        msStartingFileFormatLabel.setText("\u0418\u0441\u0445\u043e\u0434\u043d\u044b\u0439 \u0444\u043e\u0440\u043c\u0430\u0442");

        msResultingFileFormatLabel.setText("\u0420\u0435\u0437\u0443\u043b\u044c\u0442\u0438\u0440\u0443\u044e\u0449\u0438\u0439 \u0444\u043e\u0440\u043c\u0430\u0442");

        msStartingFileEncodingLabel.setText("\u0418\u0441\u0445\u043e\u0434\u043d\u0430\u044f \u043a\u043e\u0434\u0438\u0440\u043e\u0432\u043a\u0430");

        mResultingFileEncodingLabel.setText("\u0420\u0435\u0437\u0443\u043b\u044c\u0442\u0438\u0440\u0443\u044e\u0449\u0430\u044f \u043a\u043e\u0434\u0438\u0440\u043e\u0432\u043a\u0430");

        org.jdesktop.layout.GroupLayout mOptionsPanelLayout = new org.jdesktop.layout.GroupLayout(mOptionsPanel);
        mOptionsPanel.setLayout(mOptionsPanelLayout);
        mOptionsPanelLayout.setHorizontalGroup(
            mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mOptionsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, mOptionsLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, mOptionsPanelLayout.createSequentialGroup()
                        .add(mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, mResultingFileEncodingLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 147, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, msResultingFileFormatLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 147, Short.MAX_VALUE)
                            .add(msStartingFileEncodingLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 147, Short.MAX_VALUE)
                            .add(msStartingFileFormatLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 147, Short.MAX_VALUE))
                        .add(24, 24, 24)
                        .add(mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, msStartingFileFormatComboBox, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, msStartingFileEncodingComboBox, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, mResultingFileFormatComboBox, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, mResultingFileEncodingComboBox, 0, 235, Short.MAX_VALUE))))
                .addContainerGap())
        );
        mOptionsPanelLayout.setVerticalGroup(
            mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mOptionsPanelLayout.createSequentialGroup()
                .add(mOptionsLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(msStartingFileFormatLabel)
                    .add(msStartingFileFormatComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(9, 9, 9)
                .add(mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(msStartingFileEncodingLabel)
                    .add(msStartingFileEncodingComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(msResultingFileFormatLabel)
                    .add(mResultingFileFormatComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(7, 7, 7)
                .add(mOptionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(mResultingFileEncodingLabel)
                    .add(mResultingFileEncodingComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(23, 23, 23))
        );

        mConvertingPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
        mConvertingLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        mConvertingLabel.setText("\u041a\u043e\u043d\u0432\u0435\u0440\u0442\u0438\u0440\u043e\u0432\u0430\u043d\u0438\u0435");

        mConvertingMessagesList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(mConvertingMessagesList);

        org.jdesktop.layout.GroupLayout mConvertingPanelLayout = new org.jdesktop.layout.GroupLayout(mConvertingPanel);
        mConvertingPanel.setLayout(mConvertingPanelLayout);
        mConvertingPanelLayout.setHorizontalGroup(
            mConvertingPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, mConvertingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(mConvertingPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, mConvertingLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE))
                .addContainerGap())
        );
        mConvertingPanelLayout.setVerticalGroup(
            mConvertingPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mConvertingPanelLayout.createSequentialGroup()
                .add(mConvertingLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, mConvertingButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 430, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, mOptionsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, mFilesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, mConvertingPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(mFilesPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(9, 9, 9)
                .add(mOptionsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 148, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mConvertingButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 32, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mConvertingPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void mConvertingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mConvertingButtonActionPerformed
        
        Integer lStartingFileFormat = msStartingFileFormatComboBox.getSelectedIndex();
        Integer lResultingFileFormat = mResultingFileFormatComboBox.getSelectedIndex();
        Integer lStartingFileEncoding = msStartingFileEncodingComboBox.getSelectedIndex();
        Integer lResultingFileEncoding = mResultingFileEncodingComboBox.getSelectedIndex();
        
        mConverter.setSourceFile( mSourceFileField.getText().trim() );
        mConverter.setDestinationFile( mDestinationFileField.getText().trim() );
        
        Vector< String > lLog = mConverter.build(
                lStartingFileFormat,
                lResultingFileFormat,
                lStartingFileEncoding,
                lResultingFileEncoding );
        DefaultListModel lLogMessages = new DefaultListModel();
        for( int iMessage = 0; iMessage < lLog.size(); iMessage++ ) {
            lLogMessages.addElement( 
                    ( iMessage + 1 ) + ". " + 
                    lLog.get( iMessage ) );
        }        
        mConvertingMessagesList.setModel( 
                lLogMessages );
        mConvertingMessagesList.validate();        
    }//GEN-LAST:event_mConvertingButtonActionPerformed

    private void mDestinationFileChooseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mDestinationFileChooseButtonActionPerformed
        JFileChooser lChooser = new JFileChooser();
        lChooser.setDialogTitle( "\u0424\u0430\u0439\u043b \u043d\u0430\u0437\u043d\u0430\u0447\u0435\u043d\u0438\u044f" );
        lChooser.setApproveButtonText( "\u0412\u044b\u0431\u0440\u0430\u0442\u044c" );
        lChooser.setApproveButtonToolTipText( "\u0412\u044b\u0431\u0440\u0430\u0442\u044c \u0444\u0430\u0439\u043b \u043d\u0430\u0437\u043d\u0430\u0447\u0435\u043d\u0438\u044f" );
        lChooser.setCurrentDirectory( new File( "." ) );
        lChooser.setFileFilter(
                new javax.swing.filechooser.FileFilter() {
                    public boolean accept(
                            File pFile ) {
                        if( pFile.isDirectory() ) {
                            return true;
                        }
                        if( pFile.getName().toUpperCase().endsWith( ".XML" ) ) {
                            return true;
                        }
                        if( pFile.getName().toUpperCase().endsWith( ".TXT" ) ) {
                            return true;
                        }
                        return false;
                    }
                    public String getDescription() {
                        return new String( "\u0424\u0430\u0439\u043b\u044b \u0442\u0435\u0441\u0442\u043e\u0432" );
                    }
                }
        );
        int lResult = lChooser.showSaveDialog( this );
        if( lResult == JFileChooser.APPROVE_OPTION ) {
            mDestinationFileField.setText( lChooser.getSelectedFile().getAbsolutePath() );
        }
    }//GEN-LAST:event_mDestinationFileChooseButtonActionPerformed

    private void mSourceFileChooseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mSourceFileChooseButtonActionPerformed
        JFileChooser lChooser = new JFileChooser();
        lChooser.setDialogTitle( "\u0418\u0441\u0445\u043e\u0434\u043d\u044b\u0439 \u0444\u0430\u0439\u043b" );
        lChooser.setApproveButtonText( "\u0412\u044b\u0431\u0440\u0430\u0442\u044c" );
        lChooser.setApproveButtonToolTipText( "\u0412\u044b\u0431\u0440\u0430\u0442\u044c \u0438\u0441\u0445\u043e\u0434\u043d\u044b\u0439 \u0444\u0430\u0439\u043b" );
        lChooser.setCurrentDirectory( new File( "." ) );
        lChooser.setFileFilter(
                new javax.swing.filechooser.FileFilter() {
                    public boolean accept(
                            File pFile ) {
                        if( pFile.isDirectory() ) {
                            return true;
                        }
                        if( pFile.getName().toUpperCase().endsWith( ".XML" ) ) {
                            return true;
                        }
                        if( pFile.getName().toUpperCase().endsWith( ".TXT" ) ) {
                            return true;
                        }
                        return false;
                    }
                    public String getDescription() {
                        return new String( "\u0424\u0430\u0439\u043b\u044b \u0442\u0435\u0441\u0442\u043e\u0432" );
                    }
                }
        );
        int lResult = lChooser.showOpenDialog( this );
        if( lResult == JFileChooser.APPROVE_OPTION ) {
            mSourceFileField.setText( lChooser.getSelectedFile().getAbsolutePath() );
        }
    }//GEN-LAST:event_mSourceFileChooseButtonActionPerformed
        
    public static void main( 
            String args[ ] ) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LightClient().setVisible( true );
            }
        } );
    }
    
    private DocumentsConverter mConverter;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton mConvertingButton;
    private javax.swing.JLabel mConvertingLabel;
    private javax.swing.JList mConvertingMessagesList;
    private javax.swing.JPanel mConvertingPanel;
    private javax.swing.JButton mDestinationFileChooseButton;
    private javax.swing.JTextField mDestinationFileField;
    private javax.swing.JLabel mDestinationFileLabel;
    private javax.swing.JLabel mFilesLabel;
    private javax.swing.JPanel mFilesPanel;
    private javax.swing.JLabel mOptionsLabel;
    private javax.swing.JPanel mOptionsPanel;
    private javax.swing.JComboBox mResultingFileEncodingComboBox;
    private javax.swing.JLabel mResultingFileEncodingLabel;
    private javax.swing.JComboBox mResultingFileFormatComboBox;
    private javax.swing.JButton mSourceFileChooseButton;
    private javax.swing.JTextField mSourceFileField;
    private javax.swing.JLabel mSourceFileLabel;
    private javax.swing.JLabel msResultingFileFormatLabel;
    private javax.swing.JComboBox msStartingFileEncodingComboBox;
    private javax.swing.JLabel msStartingFileEncodingLabel;
    private javax.swing.JComboBox msStartingFileFormatComboBox;
    private javax.swing.JLabel msStartingFileFormatLabel;
    // End of variables declaration//GEN-END:variables
}