package writers;

import tests.*;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;

import java.util.Vector;

public class TXTBetaTestWriter 
    extends FileTestWriter {
    
    public TXTBetaTestWriter() {
    }
    
    public boolean write(
            Test pTest ) {
        
        if( pTest == null ) {
            return false;
        }
        if( ! prepareOStream() ) {
            return false;
        }
        
        mLog = new Vector< String >();
        
        try {
            writeEncodingSignature( mOStream );
            
            Description pDescription = pTest.getDescription();
            // Need to work on year
            Integer Year = 2005;
            
            writeParameters(pDescription.GetSubject(),pDescription.GetTitle(),Year);
            writeAuthors( pTest.getAuthors() );

            writeQuestions( pTest.getQuestions() );
        } catch( Exception eCreatinoFailed ) {
            mLog.add( "Destination file writing failed." );
            mDestinationFile.delete();
            return false;
        }
        return true;
    }
    
    private void writeParameters(
            String pSubject,
            String pTitle,
            Integer pYear )
            throws Exception {
        
        mOStream.write( new String( pSubject + "\r\n" ).getBytes( mEncoding ) );
        mOStream.write( new String( pTitle + "\r\n" ).getBytes( mEncoding ) );
        mOStream.write( new String( pYear.toString() + "\r\n" ).getBytes( mEncoding ) );
        mOStream.write( new String( "\r\n" ).getBytes( mEncoding ) );
    }
    
    private void writeAuthors(
            Vector <Author> pAuthors )
            throws Exception {
        
        for (Integer CurrentAuthor = 0; CurrentAuthor < pAuthors.size(); CurrentAuthor++)
        {
            // Write Author
            mOStream.write( new String( pAuthors.get(CurrentAuthor).getSurname() + " " ).getBytes( mEncoding ) );
            mOStream.write( new String( pAuthors.get(CurrentAuthor).getName() + " " ).getBytes( mEncoding ) );
            mOStream.write( pAuthors.get(CurrentAuthor).getPatronymic().getBytes( mEncoding ) );
            mOStream.write( new String( "\r\n" ).getBytes( mEncoding ) );
            // Write author department
            writeDepartment(pAuthors.get(CurrentAuthor).getDepartment());
        }
        
        mOStream.write( new String( "\r\n" ).getBytes( mEncoding ) );
    }
    
    private void writeDepartment(
            Department pDepartment )
            throws Exception {
        
        mOStream.write( new String( pDepartment.getUniversity() + "\r\n" ).getBytes( mEncoding ) );
        mOStream.write( new String( pDepartment.getFaculty() + "\r\n" ).getBytes( mEncoding ) );
        mOStream.write( new String( pDepartment.getSubFaculty() + "\r\n" ).getBytes( mEncoding ) );
    }
    
    private void writeQuestions(
            Vector< Question > pQuestions )
            throws Exception {
        
        mOStream.write( new String( pQuestions.size() + "\r\n" ).getBytes( mEncoding ) );
        for( int iQuestion = 0; iQuestion < pQuestions.size(); iQuestion++ ) {
            mOStream.write( new String( "\r\n" ).getBytes( mEncoding ) );
            Question lQuestion = pQuestions.get( iQuestion );
            if( lQuestion.getType() == QuestionType.Simple ) {
                mOStream.write( new String( lQuestion.getContent() + "\r\n" ).getBytes( mEncoding ) );
                mOStream.write( new String( 1 + "\r\n" ).getBytes( mEncoding ) );
                Vector< Answer > lAnswers = lQuestion.getAnswers();
                for( int iAnswer = 0; iAnswer < lAnswers.size(); iAnswer++ ) {
                    Answer lAnswer = lAnswers.get( iAnswer );
                    mOStream.write( new String( lAnswer.getContent() + "\r\n" ).getBytes( mEncoding ) );
                    mOStream.write( new String( lAnswer.getCorrect() + "\r\n" ).getBytes( mEncoding ) );
                }
            }
        }
    }

}